=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class AggregationQuery
    # Behaves like one clause in a SQL WHERE. Specifies the date and time range of data being queried. Intervals are represented as an ISO-8601 string. For example: YYYY-MM-DDThh:mm:ss/YYYY-MM-DDThh:mm:ss
    attr_accessor :interval

    # Granularity aggregates metrics into subpartitions within the time interval specified. The default granularity is the same duration as the interval. Periods are represented as an ISO-8601 string. For example: P1D or P1DT12H
    attr_accessor :granularity

    # Sets the time zone for the query interval, defaults to UTC. Time zones are represented as a string of the zone name as found in the IANA time zone database. For example: UTC, Etc/UTC, or Europe/London
    attr_accessor :time_zone

    # Behaves like a SQL GROUPBY. Allows for multiple levels of grouping as a list of dimensions. Partitions resulting aggregate computations into distinct named subgroups rather than across the entire result set as if it were one group.
    attr_accessor :group_by

    # Behaves like a SQL WHERE clause. This is ANDed with the interval parameter. Expresses boolean logical predicates as well as dimensional filters
    attr_accessor :filter

    # Behaves like a SQL SELECT clause. Enables retrieving only named metrics. If omitted, all metrics that are available will be returned (like SELECT *).
    attr_accessor :metrics

    # Flattens any multivalued dimensions used in response groups (e.g. ['a','b','c']->'a,b,c')
    attr_accessor :flatten_multivalued_dimensions

    # Custom derived metric views
    attr_accessor :views

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'interval' => :'interval',
        
        :'granularity' => :'granularity',
        
        :'time_zone' => :'timeZone',
        
        :'group_by' => :'groupBy',
        
        :'filter' => :'filter',
        
        :'metrics' => :'metrics',
        
        :'flatten_multivalued_dimensions' => :'flattenMultivaluedDimensions',
        
        :'views' => :'views'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'interval' => :'String',
        
        :'granularity' => :'String',
        
        :'time_zone' => :'String',
        
        :'group_by' => :'Array<String>',
        
        :'filter' => :'AnalyticsQueryFilter',
        
        :'metrics' => :'Array<String>',
        
        :'flatten_multivalued_dimensions' => :'BOOLEAN',
        
        :'views' => :'Array<AnalyticsView>'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'interval')
        
        
        self.interval = attributes[:'interval']
        
      
      end

      
      if attributes.has_key?(:'granularity')
        
        
        self.granularity = attributes[:'granularity']
        
      
      end

      
      if attributes.has_key?(:'timeZone')
        
        
        self.time_zone = attributes[:'timeZone']
        
      
      end

      
      if attributes.has_key?(:'groupBy')
        
        if (value = attributes[:'groupBy']).is_a?(Array)
          self.group_by = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'filter')
        
        
        self.filter = attributes[:'filter']
        
      
      end

      
      if attributes.has_key?(:'metrics')
        
        if (value = attributes[:'metrics']).is_a?(Array)
          self.metrics = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flattenMultivaluedDimensions')
        
        
        self.flatten_multivalued_dimensions = attributes[:'flattenMultivaluedDimensions']
        
      
      end

      
      if attributes.has_key?(:'views')
        
        if (value = attributes[:'views']).is_a?(Array)
          self.views = value
        end
        
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          interval == o.interval &&
          granularity == o.granularity &&
          time_zone == o.time_zone &&
          group_by == o.group_by &&
          filter == o.filter &&
          metrics == o.metrics &&
          flatten_multivalued_dimensions == o.flatten_multivalued_dimensions &&
          views == o.views
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [interval, granularity, time_zone, group_by, filter, metrics, flatten_multivalued_dimensions, views].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
