=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class CreateAsgRequest
    # Email address of the individual starting the ASG
    attr_accessor :asg_owner_email

    # Edge group that the user wants the asg edges to be assigned to.
    attr_accessor :edge_group_id

    # Trunk base that the user wants the asg edges to be assigned to
    attr_accessor :external_trunk_base_id

    # Overrides the default logical IAM Instance Profile
    attr_accessor :asg_logical_iam_instance_profile

    # Overrides the default EDGE AMI used with the ASG
    attr_accessor :asg_ami

    # Overrides the type of ASG being created.  By default we always create a 'standard' asg.
    attr_accessor :asg_type

    # Overrides the default number of Edge instances to start in the ASG
    attr_accessor :asg_instance_count

    # Overrides the network space the ASG will start in.  The default will always be mediaservices
    attr_accessor :asg_network_space

    # Optional parameter that exempts this ASG from chaos monkey killing one of its instances.
    attr_accessor :asg_chaos_exempt

    # Number of minutes a recovery ASG will stay active before it is torn down
    attr_accessor :asg_recovery_shutdown_minutes

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'asg_owner_email' => :'asgOwnerEmail',
        
        :'edge_group_id' => :'edgeGroupId',
        
        :'external_trunk_base_id' => :'externalTrunkBaseId',
        
        :'asg_logical_iam_instance_profile' => :'asgLogicalIAMInstanceProfile',
        
        :'asg_ami' => :'asgAmi',
        
        :'asg_type' => :'asgType',
        
        :'asg_instance_count' => :'asgInstanceCount',
        
        :'asg_network_space' => :'asgNetworkSpace',
        
        :'asg_chaos_exempt' => :'asgChaosExempt',
        
        :'asg_recovery_shutdown_minutes' => :'asgRecoveryShutdownMinutes'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'asg_owner_email' => :'String',
        
        :'edge_group_id' => :'String',
        
        :'external_trunk_base_id' => :'String',
        
        :'asg_logical_iam_instance_profile' => :'String',
        
        :'asg_ami' => :'BOOLEAN',
        
        :'asg_type' => :'String',
        
        :'asg_instance_count' => :'Integer',
        
        :'asg_network_space' => :'String',
        
        :'asg_chaos_exempt' => :'BOOLEAN',
        
        :'asg_recovery_shutdown_minutes' => :'Integer'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'asgOwnerEmail')
        
        
        self.asg_owner_email = attributes[:'asgOwnerEmail']
        
      
      end

      
      if attributes.has_key?(:'edgeGroupId')
        
        
        self.edge_group_id = attributes[:'edgeGroupId']
        
      
      end

      
      if attributes.has_key?(:'externalTrunkBaseId')
        
        
        self.external_trunk_base_id = attributes[:'externalTrunkBaseId']
        
      
      end

      
      if attributes.has_key?(:'asgLogicalIAMInstanceProfile')
        
        
        self.asg_logical_iam_instance_profile = attributes[:'asgLogicalIAMInstanceProfile']
        
      
      end

      
      if attributes.has_key?(:'asgAmi')
        
        
        self.asg_ami = attributes[:'asgAmi']
        
      
      end

      
      if attributes.has_key?(:'asgType')
        
        
        self.asg_type = attributes[:'asgType']
        
      
      end

      
      if attributes.has_key?(:'asgInstanceCount')
        
        
        self.asg_instance_count = attributes[:'asgInstanceCount']
        
      
      end

      
      if attributes.has_key?(:'asgNetworkSpace')
        
        
        self.asg_network_space = attributes[:'asgNetworkSpace']
        
      
      end

      
      if attributes.has_key?(:'asgChaosExempt')
        
        
        self.asg_chaos_exempt = attributes[:'asgChaosExempt']
        
      
      end

      
      if attributes.has_key?(:'asgRecoveryShutdownMinutes')
        
        
        self.asg_recovery_shutdown_minutes = attributes[:'asgRecoveryShutdownMinutes']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      if @asg_owner_email.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["standard", "recovery"]
      if @asg_type && !allowed_values.include?(@asg_type)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] asg_type Object to be assigned
    def asg_type=(asg_type)
      allowed_values = ["standard", "recovery"]
      if asg_type && !allowed_values.include?(asg_type)
        fail ArgumentError, "invalid value for 'asg_type', must be one of #{allowed_values}."
      end
      @asg_type = asg_type
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          asg_owner_email == o.asg_owner_email &&
          edge_group_id == o.edge_group_id &&
          external_trunk_base_id == o.external_trunk_base_id &&
          asg_logical_iam_instance_profile == o.asg_logical_iam_instance_profile &&
          asg_ami == o.asg_ami &&
          asg_type == o.asg_type &&
          asg_instance_count == o.asg_instance_count &&
          asg_network_space == o.asg_network_space &&
          asg_chaos_exempt == o.asg_chaos_exempt &&
          asg_recovery_shutdown_minutes == o.asg_recovery_shutdown_minutes
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [asg_owner_email, edge_group_id, external_trunk_base_id, asg_logical_iam_instance_profile, asg_ami, asg_type, asg_instance_count, asg_network_space, asg_chaos_exempt, asg_recovery_shutdown_minutes].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
