=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class Keyword
    attr_accessor :id

    attr_accessor :name

    # The word or phrase which is being looked for with speech recognition.
    attr_accessor :phrase

    # A sensitivity threshold that can be increased to lower false positives or decreased to reduce false negatives.
    attr_accessor :confidence

    # A modifier to the evaluation score when the phrase is spotted in the agent channel
    attr_accessor :agent_score_modifier

    # A modifier to the evaluation score when the phrase is spotted in the customer channel
    attr_accessor :customer_score_modifier

    # Other spellings of the phrase that can be added to reduce missed spots (false negatives).
    attr_accessor :alternate_spellings

    # The phonetic spellings for the phrase and alternate spellings.
    attr_accessor :pronunciations

    # Words that are similar to the phrase but not desired. Added to reduce incorrect spots (false positives).
    attr_accessor :anti_words

    # The phonetic spellings for the antiWords.
    attr_accessor :anti_pronunciations

    # A prediction of how easy it is to unambiguously spot the keyword within its language based on spelling.
    attr_accessor :spotability_index

    attr_accessor :margin_of_error

    attr_accessor :pronunciation

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'phrase' => :'phrase',
        
        :'confidence' => :'confidence',
        
        :'agent_score_modifier' => :'agentScoreModifier',
        
        :'customer_score_modifier' => :'customerScoreModifier',
        
        :'alternate_spellings' => :'alternateSpellings',
        
        :'pronunciations' => :'pronunciations',
        
        :'anti_words' => :'antiWords',
        
        :'anti_pronunciations' => :'antiPronunciations',
        
        :'spotability_index' => :'spotabilityIndex',
        
        :'margin_of_error' => :'marginOfError',
        
        :'pronunciation' => :'pronunciation'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'name' => :'String',
        
        :'phrase' => :'String',
        
        :'confidence' => :'Integer',
        
        :'agent_score_modifier' => :'Integer',
        
        :'customer_score_modifier' => :'Integer',
        
        :'alternate_spellings' => :'Array<String>',
        
        :'pronunciations' => :'Array<String>',
        
        :'anti_words' => :'Array<String>',
        
        :'anti_pronunciations' => :'Array<String>',
        
        :'spotability_index' => :'Float',
        
        :'margin_of_error' => :'Float',
        
        :'pronunciation' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'phrase')
        
        
        self.phrase = attributes[:'phrase']
        
      
      end

      
      if attributes.has_key?(:'confidence')
        
        
        self.confidence = attributes[:'confidence']
        
      
      end

      
      if attributes.has_key?(:'agentScoreModifier')
        
        
        self.agent_score_modifier = attributes[:'agentScoreModifier']
        
      
      end

      
      if attributes.has_key?(:'customerScoreModifier')
        
        
        self.customer_score_modifier = attributes[:'customerScoreModifier']
        
      
      end

      
      if attributes.has_key?(:'alternateSpellings')
        
        if (value = attributes[:'alternateSpellings']).is_a?(Array)
          self.alternate_spellings = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'pronunciations')
        
        if (value = attributes[:'pronunciations']).is_a?(Array)
          self.pronunciations = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'antiWords')
        
        if (value = attributes[:'antiWords']).is_a?(Array)
          self.anti_words = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'antiPronunciations')
        
        if (value = attributes[:'antiPronunciations']).is_a?(Array)
          self.anti_pronunciations = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'spotabilityIndex')
        
        
        self.spotability_index = attributes[:'spotabilityIndex']
        
      
      end

      
      if attributes.has_key?(:'marginOfError')
        
        
        self.margin_of_error = attributes[:'marginOfError']
        
      
      end

      
      if attributes.has_key?(:'pronunciation')
        
        
        self.pronunciation = attributes[:'pronunciation']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      if @phrase.nil?
        return false
      end

      
      
      
      
      
      if @confidence.nil?
        return false
      end

      
      
      
      
      
      if @agent_score_modifier.nil?
        return false
      end

      
      
      
      
      
      if @customer_score_modifier.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          phrase == o.phrase &&
          confidence == o.confidence &&
          agent_score_modifier == o.agent_score_modifier &&
          customer_score_modifier == o.customer_score_modifier &&
          alternate_spellings == o.alternate_spellings &&
          pronunciations == o.pronunciations &&
          anti_words == o.anti_words &&
          anti_pronunciations == o.anti_pronunciations &&
          spotability_index == o.spotability_index &&
          margin_of_error == o.margin_of_error &&
          pronunciation == o.pronunciation
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, phrase, confidence, agent_score_modifier, customer_score_modifier, alternate_spellings, pronunciations, anti_words, anti_pronunciations, spotability_index, margin_of_error, pronunciation].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
