=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class Site
    # The globally unique identifier for the object.
    attr_accessor :id

    # The name of the entity.
    attr_accessor :name

    # The resource's description.
    attr_accessor :description

    # The current version of the resource.
    attr_accessor :version

    # The date the resource was created. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_created

    # The date of the last modification to the resource. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_modified

    # The ID of the user that last modified the resource.
    attr_accessor :modified_by

    # The ID of the user that created the resource.
    attr_accessor :created_by

    # Indicates if the resource is active, inactive, or deleted.
    attr_accessor :state

    # The application that last modified the resource.
    attr_accessor :modified_by_app

    # The application that created the resource.
    attr_accessor :created_by_app

    attr_accessor :primary_sites

    attr_accessor :secondary_sites

    attr_accessor :primary_edges

    attr_accessor :secondary_edges

    attr_accessor :addresses

    attr_accessor :edges

    # Recurrance rule, time zone, and start/end settings for automatic edge updates for this site
    attr_accessor :edge_auto_update_config

    # Location
    attr_accessor :location

    attr_accessor :managed

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'description' => :'description',
        
        :'version' => :'version',
        
        :'date_created' => :'dateCreated',
        
        :'date_modified' => :'dateModified',
        
        :'modified_by' => :'modifiedBy',
        
        :'created_by' => :'createdBy',
        
        :'state' => :'state',
        
        :'modified_by_app' => :'modifiedByApp',
        
        :'created_by_app' => :'createdByApp',
        
        :'primary_sites' => :'primarySites',
        
        :'secondary_sites' => :'secondarySites',
        
        :'primary_edges' => :'primaryEdges',
        
        :'secondary_edges' => :'secondaryEdges',
        
        :'addresses' => :'addresses',
        
        :'edges' => :'edges',
        
        :'edge_auto_update_config' => :'edgeAutoUpdateConfig',
        
        :'location' => :'location',
        
        :'managed' => :'managed',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'name' => :'String',
        
        :'description' => :'String',
        
        :'version' => :'Integer',
        
        :'date_created' => :'DateTime',
        
        :'date_modified' => :'DateTime',
        
        :'modified_by' => :'String',
        
        :'created_by' => :'String',
        
        :'state' => :'String',
        
        :'modified_by_app' => :'String',
        
        :'created_by_app' => :'String',
        
        :'primary_sites' => :'Array<UriReference>',
        
        :'secondary_sites' => :'Array<UriReference>',
        
        :'primary_edges' => :'Array<Edge>',
        
        :'secondary_edges' => :'Array<Edge>',
        
        :'addresses' => :'Array<Contact>',
        
        :'edges' => :'Array<Edge>',
        
        :'edge_auto_update_config' => :'EdgeAutoUpdateConfig',
        
        :'location' => :'LocationDefinition',
        
        :'managed' => :'BOOLEAN',
        
        :'self_uri' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'description')
        
        
        self.description = attributes[:'description']
        
      
      end

      
      if attributes.has_key?(:'version')
        
        
        self.version = attributes[:'version']
        
      
      end

      
      if attributes.has_key?(:'dateCreated')
        
        
        self.date_created = attributes[:'dateCreated']
        
      
      end

      
      if attributes.has_key?(:'dateModified')
        
        
        self.date_modified = attributes[:'dateModified']
        
      
      end

      
      if attributes.has_key?(:'modifiedBy')
        
        
        self.modified_by = attributes[:'modifiedBy']
        
      
      end

      
      if attributes.has_key?(:'createdBy')
        
        
        self.created_by = attributes[:'createdBy']
        
      
      end

      
      if attributes.has_key?(:'state')
        
        
        self.state = attributes[:'state']
        
      
      end

      
      if attributes.has_key?(:'modifiedByApp')
        
        
        self.modified_by_app = attributes[:'modifiedByApp']
        
      
      end

      
      if attributes.has_key?(:'createdByApp')
        
        
        self.created_by_app = attributes[:'createdByApp']
        
      
      end

      
      if attributes.has_key?(:'primarySites')
        
        if (value = attributes[:'primarySites']).is_a?(Array)
          self.primary_sites = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'secondarySites')
        
        if (value = attributes[:'secondarySites']).is_a?(Array)
          self.secondary_sites = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'primaryEdges')
        
        if (value = attributes[:'primaryEdges']).is_a?(Array)
          self.primary_edges = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'secondaryEdges')
        
        if (value = attributes[:'secondaryEdges']).is_a?(Array)
          self.secondary_edges = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'addresses')
        
        if (value = attributes[:'addresses']).is_a?(Array)
          self.addresses = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'edges')
        
        if (value = attributes[:'edges']).is_a?(Array)
          self.edges = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'edgeAutoUpdateConfig')
        
        
        self.edge_auto_update_config = attributes[:'edgeAutoUpdateConfig']
        
      
      end

      
      if attributes.has_key?(:'location')
        
        
        self.location = attributes[:'location']
        
      
      end

      
      if attributes.has_key?(:'managed')
        
        
        self.managed = attributes[:'managed']
        
      
      end

      
      if attributes.has_key?(:'selfUri')
        
        
        self.self_uri = attributes[:'selfUri']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      if @name.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["active", "inactive", "deleted"]
      if @state && !allowed_values.include?(@state)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      if @location.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] state Object to be assigned
    def state=(state)
      allowed_values = ["active", "inactive", "deleted"]
      if state && !allowed_values.include?(state)
        fail ArgumentError, "invalid value for 'state', must be one of #{allowed_values}."
      end
      @state = state
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          description == o.description &&
          version == o.version &&
          date_created == o.date_created &&
          date_modified == o.date_modified &&
          modified_by == o.modified_by &&
          created_by == o.created_by &&
          state == o.state &&
          modified_by_app == o.modified_by_app &&
          created_by_app == o.created_by_app &&
          primary_sites == o.primary_sites &&
          secondary_sites == o.secondary_sites &&
          primary_edges == o.primary_edges &&
          secondary_edges == o.secondary_edges &&
          addresses == o.addresses &&
          edges == o.edges &&
          edge_auto_update_config == o.edge_auto_update_config &&
          location == o.location &&
          managed == o.managed &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, description, version, date_created, date_modified, modified_by, created_by, state, modified_by_app, created_by_app, primary_sites, secondary_sites, primary_edges, secondary_edges, addresses, edges, edge_auto_update_config, location, managed, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
