=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class TimeOffRequest
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    # The user associated with this TimeOffRequest
    attr_accessor :user

    # Whether this is a full day request (false means partial day)
    attr_accessor :is_full_day_request

    # Whether this request has been marked as read by the agent
    attr_accessor :marked_as_read

    # The ID of the activity code associated with this TimeOffRequest
    attr_accessor :activity_code_id

    # The administrative status of this TimeOffRequest
    attr_accessor :status

    # The start date-times for partial day requests.  Required if isFullDayRequest == false
    attr_accessor :partial_day_start_date_times

    # The daily duration of this TimeOffRequest in minutes
    attr_accessor :daily_duration_minutes

    # The notes as input by the one who entered the TimeOffRequest
    attr_accessor :notes

    # The user who submitted this TimeOffRequest
    attr_accessor :submitted_by

    # The timestamp when this request was submitted. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :submitted_date

    # The user who reviewed this TimeOffRequest
    attr_accessor :reviewed_by

    # The timestamp when this request was reviewed. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :reviewed_date

    # The user who last modified this TimeOffRequest
    attr_accessor :modified_by

    # The timestamp when this request was last modified. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :modified_date

    # The URI for this object
    attr_accessor :self_uri

    # ISO-8601 date only with no timezones.  Should be interpreted in the Management Unit's configured time zone.  Required if isFullDayRequest == true
    attr_accessor :full_day_management_unit_dates

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'user' => :'user',
        
        :'is_full_day_request' => :'isFullDayRequest',
        
        :'marked_as_read' => :'markedAsRead',
        
        :'activity_code_id' => :'activityCodeId',
        
        :'status' => :'status',
        
        :'partial_day_start_date_times' => :'partialDayStartDateTimes',
        
        :'daily_duration_minutes' => :'dailyDurationMinutes',
        
        :'notes' => :'notes',
        
        :'submitted_by' => :'submittedBy',
        
        :'submitted_date' => :'submittedDate',
        
        :'reviewed_by' => :'reviewedBy',
        
        :'reviewed_date' => :'reviewedDate',
        
        :'modified_by' => :'modifiedBy',
        
        :'modified_date' => :'modifiedDate',
        
        :'self_uri' => :'selfUri',
        
        :'full_day_management_unit_dates' => :'fullDayManagementUnitDates'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'name' => :'String',
        
        :'user' => :'User',
        
        :'is_full_day_request' => :'BOOLEAN',
        
        :'marked_as_read' => :'BOOLEAN',
        
        :'activity_code_id' => :'String',
        
        :'status' => :'String',
        
        :'partial_day_start_date_times' => :'Array<DateTime>',
        
        :'daily_duration_minutes' => :'Integer',
        
        :'notes' => :'String',
        
        :'submitted_by' => :'User',
        
        :'submitted_date' => :'DateTime',
        
        :'reviewed_by' => :'User',
        
        :'reviewed_date' => :'DateTime',
        
        :'modified_by' => :'User',
        
        :'modified_date' => :'DateTime',
        
        :'self_uri' => :'String',
        
        :'full_day_management_unit_dates' => :'Array<String>'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'user')
        
        
        self.user = attributes[:'user']
        
      
      end

      
      if attributes.has_key?(:'isFullDayRequest')
        
        
        self.is_full_day_request = attributes[:'isFullDayRequest']
        
      
      end

      
      if attributes.has_key?(:'markedAsRead')
        
        
        self.marked_as_read = attributes[:'markedAsRead']
        
      
      end

      
      if attributes.has_key?(:'activityCodeId')
        
        
        self.activity_code_id = attributes[:'activityCodeId']
        
      
      end

      
      if attributes.has_key?(:'status')
        
        
        self.status = attributes[:'status']
        
      
      end

      
      if attributes.has_key?(:'partialDayStartDateTimes')
        
        if (value = attributes[:'partialDayStartDateTimes']).is_a?(Array)
          self.partial_day_start_date_times = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'dailyDurationMinutes')
        
        
        self.daily_duration_minutes = attributes[:'dailyDurationMinutes']
        
      
      end

      
      if attributes.has_key?(:'notes')
        
        
        self.notes = attributes[:'notes']
        
      
      end

      
      if attributes.has_key?(:'submittedBy')
        
        
        self.submitted_by = attributes[:'submittedBy']
        
      
      end

      
      if attributes.has_key?(:'submittedDate')
        
        
        self.submitted_date = attributes[:'submittedDate']
        
      
      end

      
      if attributes.has_key?(:'reviewedBy')
        
        
        self.reviewed_by = attributes[:'reviewedBy']
        
      
      end

      
      if attributes.has_key?(:'reviewedDate')
        
        
        self.reviewed_date = attributes[:'reviewedDate']
        
      
      end

      
      if attributes.has_key?(:'modifiedBy')
        
        
        self.modified_by = attributes[:'modifiedBy']
        
      
      end

      
      if attributes.has_key?(:'modifiedDate')
        
        
        self.modified_date = attributes[:'modifiedDate']
        
      
      end

      
      if attributes.has_key?(:'selfUri')
        
        
        self.self_uri = attributes[:'selfUri']
        
      
      end

      
      if attributes.has_key?(:'fullDayManagementUnitDates')
        
        if (value = attributes[:'fullDayManagementUnitDates']).is_a?(Array)
          self.full_day_management_unit_dates = value
        end
        
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      if @user.nil?
        return false
      end

      
      
      
      
      
      if @is_full_day_request.nil?
        return false
      end

      
      
      
      
      
      if @marked_as_read.nil?
        return false
      end

      
      
      
      
      
      if @activity_code_id.nil?
        return false
      end

      
      
      
      
      
      if @status.nil?
        return false
      end

      
      
      allowed_values = ["PENDING", "APPROVED", "DENIED", "CANCELED"]
      if @status && !allowed_values.include?(@status)
        return false
      end
      
      
      
      
      
      
      
      
      if @daily_duration_minutes.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      allowed_values = ["PENDING", "APPROVED", "DENIED", "CANCELED"]
      if status && !allowed_values.include?(status)
        fail ArgumentError, "invalid value for 'status', must be one of #{allowed_values}."
      end
      @status = status
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          user == o.user &&
          is_full_day_request == o.is_full_day_request &&
          marked_as_read == o.marked_as_read &&
          activity_code_id == o.activity_code_id &&
          status == o.status &&
          partial_day_start_date_times == o.partial_day_start_date_times &&
          daily_duration_minutes == o.daily_duration_minutes &&
          notes == o.notes &&
          submitted_by == o.submitted_by &&
          submitted_date == o.submitted_date &&
          reviewed_by == o.reviewed_by &&
          reviewed_date == o.reviewed_date &&
          modified_by == o.modified_by &&
          modified_date == o.modified_date &&
          self_uri == o.self_uri &&
          full_day_management_unit_dates == o.full_day_management_unit_dates
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, user, is_full_day_request, marked_as_read, activity_code_id, status, partial_day_start_date_times, daily_duration_minutes, notes, submitted_by, submitted_date, reviewed_by, reviewed_date, modified_by, modified_date, self_uri, full_day_management_unit_dates].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
