=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: ININ
http://www.inin.com

Terms of Service: https://developer.mypurecloud.com/tos

=end

require 'date'

module PureCloud
  class UserDetailsQuery
    # Specifies the date and time range of data being queried. Conversations MUST have started within this time range to potentially be included within the result set. Intervals are represented as an ISO-8601 string. For example: YYYY-MM-DDThh:mm:ss/YYYY-MM-DDThh:mm:ss
    attr_accessor :interval

    # Filters that target the users to retrieve data for
    attr_accessor :user_filters

    # Filters that target system and organization presence-level data
    attr_accessor :presence_filters

    # Filters that target agent routing status-level data
    attr_accessor :routing_status_filters

    # Include faceted search and aggregate roll-ups of presence data in your search results. This does not function as a filter, but rather, summary data about the presence results matching your filters
    attr_accessor :presence_aggregations

    # Include faceted search and aggregate roll-ups of agent routing status data in your search results. This does not function as a filter, but rather, summary data about the agent routing status results matching your filters
    attr_accessor :routing_status_aggregations

    # Page size and number to control iterating through large result sets. Default page size is 25
    attr_accessor :paging

    # Sort the result set in ascending/descending order. Default is ascending
    attr_accessor :order

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'interval' => :'interval',
        
        :'user_filters' => :'userFilters',
        
        :'presence_filters' => :'presenceFilters',
        
        :'routing_status_filters' => :'routingStatusFilters',
        
        :'presence_aggregations' => :'presenceAggregations',
        
        :'routing_status_aggregations' => :'routingStatusAggregations',
        
        :'paging' => :'paging',
        
        :'order' => :'order'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'interval' => :'String',
        
        :'user_filters' => :'Array<AnalyticsQueryFilter>',
        
        :'presence_filters' => :'Array<AnalyticsQueryFilter>',
        
        :'routing_status_filters' => :'Array<AnalyticsQueryFilter>',
        
        :'presence_aggregations' => :'Array<AnalyticsQueryAggregation>',
        
        :'routing_status_aggregations' => :'Array<AnalyticsQueryAggregation>',
        
        :'paging' => :'PagingSpec',
        
        :'order' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'interval')
        
        
        self.interval = attributes[:'interval']
        
      
      end

      
      if attributes.has_key?(:'userFilters')
        
        if (value = attributes[:'userFilters']).is_a?(Array)
          self.user_filters = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'presenceFilters')
        
        if (value = attributes[:'presenceFilters']).is_a?(Array)
          self.presence_filters = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'routingStatusFilters')
        
        if (value = attributes[:'routingStatusFilters']).is_a?(Array)
          self.routing_status_filters = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'presenceAggregations')
        
        if (value = attributes[:'presenceAggregations']).is_a?(Array)
          self.presence_aggregations = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'routingStatusAggregations')
        
        if (value = attributes[:'routingStatusAggregations']).is_a?(Array)
          self.routing_status_aggregations = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'paging')
        
        
        self.paging = attributes[:'paging']
        
      
      end

      
      if attributes.has_key?(:'order')
        
        
        self.order = attributes[:'order']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["asc", "desc"]
      if @order && !allowed_values.include?(@order)
        return false
      end
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] order Object to be assigned
    def order=(order)
      allowed_values = ["asc", "desc"]
      if order && !allowed_values.include?(order)
        fail ArgumentError, "invalid value for 'order', must be one of #{allowed_values}."
      end
      @order = order
    end

    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          interval == o.interval &&
          user_filters == o.user_filters &&
          presence_filters == o.presence_filters &&
          routing_status_filters == o.routing_status_filters &&
          presence_aggregations == o.presence_aggregations &&
          routing_status_aggregations == o.routing_status_aggregations &&
          paging == o.paging &&
          order == o.order
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [interval, user_filters, presence_filters, routing_status_filters, presence_aggregations, routing_status_aggregations, paging, order].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
